Index: main/trunk/model-sites-dev/waikato-edu/collect/maths-activities/DATA-PREPARATION/README-maths.txt
===================================================================
--- main/trunk/model-sites-dev/waikato-edu/collect/maths-activities/DATA-PREPARATION/README-maths.txt	(revision 33695)
+++ main/trunk/model-sites-dev/waikato-edu/collect/maths-activities/DATA-PREPARATION/README-maths.txt	(revision 33695)
@@ -0,0 +1,121 @@
+------------------------------------------
+README FOR THE MATH ACTIVITIES COLLECTION
+------------------------------------------
+INDEX:
+A. RECREATING THE maths-activities GREENSTONE COLLECTION's import FOLDER'S CONTENTS FROM SCRATCH
+B. INSTRUCTIONS ON REBUILDING THE maths-activities GREENSTONE COLLECTION, IF THE COLLECTION'S import FOLDER IS NON-EMPTY
+C. HOW TO CREATE ANOTHER EDUCATION DEPT'S ACTIVITY COLLECTION
+D. FOR FURTHER INFORMATION ON GREENSTONE
+
+
+
+A. RECREATING THE maths-activities GREENSTONE COLLECTION's import FOLDER'S CONTENTS FROM SCRATCH
+---------------------------------------------------------------------------------------------
+This section deals with preparing the import folder of the maths-activities so you can rebuild it with updated data.
+This section of the README contains instructions exclusive to Windows machines. However, a Greenstone collection's "import" folder that's prepared according to these instructions on a Windows machine, can then be moved into a "maths-activities" collection on Unix (Linux and Mac) operating systems that run Greenstone 3.09 or later.
+
+You would choose to recreate the import folder's contents of the maths-activities from scratch if:
+- the maths-activities/import subfolder is empty
+- you have moved about some files and folders of the Math Resource Activities folder that serves as source (input) to creating the maths-activities's import subfolder.
+
+To prepare the maths-activities/import folder's contents from scratch,
+
+0. Inspect the image "screenshot-input-mathfolder-organisation.png" which is a screengrab of how the contents of the Math Resource Activities folder could be organised. In the screenshot:
+- The top-level folder structure of the Math Resource Activities is shown to the right within the screenshot, and to the left you can see that one of the primary Activities, Algebra, has been expanded revealing the folder structure underneath.
+- A further subfolder is also expanded on the left: "Hooked on Algebra". Not shown is that this subfolder, expanded as an example, contains the files "Fishy Algebra.jpg" and "Hooked on Algebra.pdf".
+
+Liang Li organised the contents of the Math Resource Activities folder as seen in the screenshot. Others may decide on a different organisation of its contents. 
+In that case, you want to make sure that your Math Resources Activities folder is hierarchically organised in a similarly sensible fashion. You're free to move across folders and subfolders as you please, and add new ones, just be aware that the folder and subfolder hierarchical structure you create within Math Resources Activities will be reflected in the final Greenstone collection. 
+IMPORTANT: Also be aware that while the code can cope with spaces, you want to avoid "&" and other tricky characters (e.g. proper quote marks) in names of files and folders. Naming things correctly at this stage will save a lot of grief later. Use "and" in place of "&" for instance in file/folder names, drop quotation marks and colons. If in doubt about any character, replace with a simpler one. Hyphens and underscores are fine. Replace forward slashes, "/", in file/folder names, because "/" has a special meaning in Greenstone.
+
+1. Once you've finished reorganising the Math Resources Activities folder, copy the file "procMath.bat" (a custom made Windows specific script) into the top level of the Math Resources Activities folder.
+
+2. Double-click the procMath.bat file and it should run against the structured contents within your Math Resources Activities folder. You can see it's doing something because a black window should pop up wherein lots of text is displayed.
+
+NOTE: If you have heard of something called the "Windows DOS prompt" and know how to use it, you can use the DOS prompt to run the procMath.bat file too, instead of double clicking it as described above. This is useful for finding any issues (a process known as "debugging") in the event that something goes wrong in processing your Math Resources Activities folder. For example if you used unacceptable characters in file and folder names.
+
+3. After a little while the black window that popped up should disappear again, meaning the procMath.bat script has finished processing your Math Resources Activities folder. 
+
+As a result of running procMath.bat successfully, you'll now have a folder called "import" residing at the same level as your Math Resources Activities folder.
+
+4. Move all the contents of this import folder, except its toplevel "metadata.xml" file into your "maths-activities/import" subfolder. Then you may delete the "import" folder produced in steps 2 and 3 above.
+
+5. Proceed with the "B. INSTRUCTIONS ON REBUILDING THE maths-activities GREENSTONE COLLECTION, IF THE COLLECTION'S import FOLDER IS NON-EMPTY" below.
+
+
+
+B. INSTRUCTIONS ON REBUILDING THE maths-activities GREENSTONE COLLECTION, IF THE COLLECTION'S import FOLDER IS NON-EMPTY
+---------------------------------------------------------------------------------------------------------------------
+
+To build the maths-activities Greenstone collection (the Math Activities collection), assuming you already have the contents of the collection "import" folder (if not, see instructions under section A above):
+
+0. Follow any instructions in the EducationDept/README.txt file first.
+
+1. Move the maths-activities into a Greenstone 3.09 installation's web/sites/waikato-edu/collect/ folder.
+
+2. Run the GLI (Greenstone Librarian Interface) application.
+
+3. Open the maths-activities collection in GLI. 
+
+4. Go into the Create panel and press the Build collection button.
+Some minutes later, the Preview Collection button will become active, meaning your collection has been built and is ready to preview. (If the Preview button does not become active despite the build process indicating that it finished "successfully", quit GLI, reopen the collection and repeat steps 2-4. You can always email us on the mailing list at greenstone_team@cs.waikato.ac.nz.)
+
+
+
+C. HOW TO CREATE ANOTHER EDUCATION DEPT'S ACTIVITY COLLECTION
+-------------------------------------------------------------
+You can create a different, new Greenstone collection similar to the Math collection by following the steps below.
+Note that step 2 below requires a Windows machine, but the remainding steps can be done on other operating systems such as Linux and Mac.
+
+1. Organise your content in a sensible hierarchical folder structure. As mentioned earlier in this README, check your file and folder names don't have "&", "/", quotes and any other characters that you think might be problematic (replace them with other characters or indicative words, e.g. replace "&" with "and").
+
+2.  THE SCRIPT IN THIS STEP REQUIRES A Windows MACHINE.
+Put the script file "procMath.bat" into the toplevel folder of the material you organised in step 1.
+
+3. Double click on the procMath.bat script. A black window will pop up. It will disappear once the script has finished processing your folder's contents.
+At the end of this process, you'll have ended up with a folder called "import" at the same level as the toplevel folder of the material you organised in step 1.
+
+4. Ensure that your Greenstone 3 installation's web/sites/waikato-edu/collect subfolder contains the maths-activities folder. If it doesn't already exist there, copy it into there.
+
+5. Run the Greenstone Librarian Interface, GLI. You'll now create a new collection based on the maths-activities:
+Go to GLI's File > New... menu. Give the new collection a name, optionally add a description. Then in the drop-down box for "Base This Collection On", choose the Maths Activities collection (maths-activities). Press OK.
+Your new collection will now have inherited the custom metadata set and overall collection design of the Math Activities collection. So you don't need to put in any effort to get the same behaviour from your new collection.
+
+IMPORTANT NOTE: if you however have scanned in documents with "OCR" on (character recognition), rather than just scanned them in as pure images, your collection and its users will greatly benefit from enabling full text searching for the new collection. To provide full text searching for your collection, click on the Design pane within GLI, then select "Search Indexes" to the left and press the "New Index..." button the right. At the top of the New Index dialog that appears, tick the topmost box, which should be labelled "Full text". Then press the "Add Index" button.
+
+You can now quit GLI. 
+
+6. Move all the contents of the "import" folder produced at the end of step 3 above, excluding its toplevel "metadata.xml" file, into your Greenstone 3 installation's web/sites/waikato-edu/collect/<new collection's name>/import folder. (Where "new collection's name" is the simplified name that got assigned to the new collection you created in step 5.)
+You can now delete the "import" folder you created in step 3.
+
+7. Run GLI again and use File > Open... to open the collection you created in step 5. 
+
+8. OPTIONAL STEP: If you want to add additional "tags" to documents or folders, to allow browsing or searching by them, then go to GLI's Enrich pane. On the left, select all files/folders for which a particular tag value is applicable and, on the right, assign this to the field labelled "er.Tag". You can create multiple er.Tags for any file/folder (or selection thereof) by hitting Enter after assigning a value for an er.Tag. This will allow you to enter a second Tag value, and so on.
+Then select other files and folders for which other tag(s) apply, and assign them similarly, until you've assigned all the tag metadata you want to the various files and folders.
+
+BEWARE: if you ever recreate your collection's "import" folder contents as in steps 3 and 6, you will lose any er.Tag values you assigned through GLI.
+
+In order to be enable Searching and Browsing by the tags you assigned, go to GLI > Design pane.
+- Choose "Search Indexes" on the right, then press the "New Index" button. In the popup dialog, scroll down until you see "er.Tag" and tick its box. Press "Add Index". Now you've prepared your collection to allow searching by tags.
+- Next, choose "Browsing Classifiers" on the left, then at the bottom on the right set "Select classifier to add" to "List" and press "Add Classifier". The dialog that pops up, next to the "metadata" configuration option at the top, choose "er.Tag" from its drop down values. Scroll further down in the dialog until you see the "buttonname" option and type "tags" as its value. Press "OK" to close the dialog. You've now configured your collection to allow users to browse by the tagging metadata that you've assigned.
+- One last thing to improve the display, go to the Format pane, select "Search" on the LEFT then you should see an Index on "er.Tag" to the right. Type "tags" in its value field, so that when the user wants to search by tags, they see the word "tags" for the index name and not "er.Tag" which will be meaningless to them.
+("er" stands for the custom EducationResources.mds metadata set created for the education department.)
+
+9. You're finally ready to rebuild your collection. Still within GLI, click on the Create pane near the top and press the "Build Collection" button. Depending on the size of your collection, this can take some time. Wait until your collection has built successfully and then press the Preview collection which should have become active at this point. Your browser should open up and you should be able to start inspecting the collection you created.
+
+
+
+D. FOR FURTHER INFORMATION ON GREENSTONE
+-----------------------------------------
+
+a. The instructions above were devised based on the instructions in the many Greenstone 3 tutorials at http://wiki.greenstone.org/doku.php?id=en:tutorials (make sure to click on the "Greenstone 3" tab near the top of that page).
+The Greenstone tutorials are recommended to learn more about Greenstone. For example, you can use what you learn in the "Using UnknownPlugin" section of the "Building a multimedia collection" to learn the basics of using the UnknownPlugin and from there it's a small step to figuring out how to configure the UnknownPlugin in your collection to add support for videos.
+
+b. Once you've gone through the Greenstone 3 tutorials, your understanding of the Greenstone software will be sufficient to understand some more advanced instructions in the Greenstone wiki. For instance, if you want use a CSV file to prepare metadata that is to be assigned to documents by Greenstone (rather than using GLI's Enrich pane), then check out the configuration options for the MetadataCSVPlugin listed at http://wiki.greenstone.org/doku.php?id=en:plugin:metadatacsvplugin
+Assigning er.Tags per filename using a CSV file will allow you to recreate your collection from scratch (by recreating the import folder) as often as you want.
+
+c. You can also join the greenstone-users mailing list to ask Greenstone questions, see http://wiki.greenstone.org/doku.php?id=en:support#central_english_mailing_lists
+Waikato University Education department staff are also welcome to write to us directly, if that's preferred, at greenstone_team@cs.waikato.ac.nz
+
+
+
Index: main/trunk/model-sites-dev/waikato-edu/collect/maths-activities/DATA-PREPARATION/README.txt
===================================================================
--- main/trunk/model-sites-dev/waikato-edu/collect/maths-activities/DATA-PREPARATION/README.txt	(revision 33694)
+++ 	(revision )
@@ -1,121 +1,0 @@
-------------------------------------------
-README FOR THE MATH ACTIVITIES COLLECTION
-------------------------------------------
-INDEX:
-A. RECREATING THE math.gs3coll GREENSTONE COLLECTION's import FOLDER'S CONTENTS FROM SCRATCH
-B. INSTRUCTIONS ON REBUILDING THE math.gs3coll GREENSTONE COLLECTION, IF THE COLLECTION'S import FOLDER IS NON-EMPTY
-C. HOW TO CREATE ANOTHER EDUCATION DEPT'S ACTIVITY COLLECTION
-D. FOR FURTHER INFORMATION ON GREENSTONE
-
-
-
-A. RECREATING THE math.gs3coll GREENSTONE COLLECTION's import FOLDER'S CONTENTS FROM SCRATCH
----------------------------------------------------------------------------------------------
-This section deals with preparing the import folder of the math.gs3coll so you can rebuild it with updated data.
-This section of the README contains instructions exclusive to Windows machines. However, a Greenstone collection's "import" folder that's prepared according to these instructions on a Windows machine, can then be moved into a "math.gs3coll" collection on Unix (Linux and Mac) operating systems that run Greenstone 3.09 or later.
-
-You would choose to recreate the import folder's contents of the math.gs3coll from scratch if:
-- the math.gs3coll/import subfolder is empty
-- you have moved about some files and folders of the Math Resource Activities folder that serves as source (input) to creating the math.gs3coll's import subfolder.
-
-To prepare the math.gs3coll/import folder's contents from scratch,
-
-0. Inspect the image "screenshot-input-mathfolder-organisation.png" which is a screengrab of how the contents of the Math Resource Activities folder could be organised. In the screenshot:
-- The top-level folder structure of the Math Resource Activities is shown to the right within the screenshot, and to the left you can see that one of the primary Activities, Algebra, has been expanded revealing the folder structure underneath.
-- A further subfolder is also expanded on the left: "Hooked on Algebra". Not shown is that this subfolder, expanded as an example, contains the files "Fishy Algebra.jpg" and "Hooked on Algebra.pdf".
-
-Liang Li organised the contents of the Math Resource Activities folder as seen in the screenshot. Others may decide on a different organisation of its contents. 
-In that case, you want to make sure that your Math Resources Activities folder is hierarchically organised in a similarly sensible fashion. You're free to move across folders and subfolders as you please, and add new ones, just be aware that the folder and subfolder hierarchical structure you create within Math Resources Activities will be reflected in the final Greenstone collection. 
-IMPORTANT: Also be aware that while the code can cope with spaces, you want to avoid "&" and other tricky characters (e.g. proper quote marks) in names of files and folders. Naming things correctly at this stage will save a lot of grief later. Use "and" in place of "&" for instance in file/folder names, drop quotation marks and colons. If in doubt about any character, replace with a simpler one. Hyphens and underscores are fine. Replace forward slashes, "/", in file/folder names, because "/" has a special meaning in Greenstone.
-
-1. Once you've finished reorganising the Math Resources Activities folder, copy the file "procMath.bat" (a custom made Windows specific script) into the top level of the Math Resources Activities folder.
-
-2. Double-click the procMath.bat file and it should run against the structured contents within your Math Resources Activities folder. You can see it's doing something because a black window should pop up wherein lots of text is displayed.
-
-NOTE: If you have heard of something called the "Windows DOS prompt" and know how to use it, you can use the DOS prompt to run the procMath.bat file too, instead of double clicking it as described above. This is useful for finding any issues (a process known as "debugging") in the event that something goes wrong in processing your Math Resources Activities folder. For example if you used unacceptable characters in file and folder names.
-
-3. After a little while the black window that popped up should disappear again, meaning the procMath.bat script has finished processing your Math Resources Activities folder. 
-
-As a result of running procMath.bat successfully, you'll now have a folder called "import" residing at the same level as your Math Resources Activities folder.
-
-4. Move all the contents of this import folder, except its toplevel "metadata.xml" file into your "math.gs3coll/import" subfolder. Then you may delete the "import" folder produced in steps 2 and 3 above.
-
-5. Proceed with the "B. INSTRUCTIONS ON REBUILDING THE math.gs3coll GREENSTONE COLLECTION, IF THE COLLECTION'S import FOLDER IS NON-EMPTY" below.
-
-
-
-B. INSTRUCTIONS ON REBUILDING THE math.gs3coll GREENSTONE COLLECTION, IF THE COLLECTION'S import FOLDER IS NON-EMPTY
----------------------------------------------------------------------------------------------------------------------
-
-To build the math.gs3coll Greenstone collection (the Math Activities collection), assuming you already have the contents of the collection "import" folder (if not, see instructions under section A above):
-
-0. Follow any instructions in the EducationDept/README.txt file first.
-
-1. Move the math.gs3coll into a Greenstone 3.09 installation's web/sites/localsite/collect/ folder.
-
-2. Run the GLI (Greenstone Librarian Interface) application.
-
-3. Open the math.gs3coll collection in GLI. 
-
-4. Go into the Create panel and press the Build collection button.
-Some minutes later, the Preview Collection button will become active, meaning your collection has been built and is ready to preview. (If the Preview button does not become active despite the build process indicating that it finished "successfully", quit GLI, reopen the collection and repeat steps 2-4. You can always email us on the mailing list at greenstone_team@cs.waikato.ac.nz.)
-
-
-
-C. HOW TO CREATE ANOTHER EDUCATION DEPT'S ACTIVITY COLLECTION
--------------------------------------------------------------
-You can create a different, new Greenstone collection similar to the Math collection by following the steps below.
-Note that step 2 below requires a Windows machine, but the remainding steps can be done on other operating systems such as Linux and Mac.
-
-1. Organise your content in a sensible hierarchical folder structure. As mentioned earlier in this README, check your file and folder names don't have "&", "/", quotes and any other characters that you think might be problematic (replace them with other characters or indicative words, e.g. replace "&" with "and").
-
-2.  THE SCRIPT IN THIS STEP REQUIRES A Windows MACHINE.
-Put the script file "procMath.bat" into the toplevel folder of the material you organised in step 1.
-
-3. Double click on the procMath.bat script. A black window will pop up. It will disappear once the script has finished processing your folder's contents.
-At the end of this process, you'll have ended up with a folder called "import" at the same level as the toplevel folder of the material you organised in step 1.
-
-4. Ensure that your Greenstone 3 installation's web/sites/localsite/collect subfolder contains the math.gs3coll folder. If it doesn't already exist there, copy it into there.
-
-5. Run the Greenstone Librarian Interface, GLI. You'll now create a new collection based on the math.gs3coll:
-Go to GLI's File > New... menu. Give the new collection a name, optionally add a description. Then in the drop-down box for "Base This Collection On", choose the Maths Activities collection (math.gs3coll). Press OK.
-Your new collection will now have inherited the custom metadata set and overall collection design of the Math Activities collection. So you don't need to put in any effort to get the same behaviour from your new collection.
-
-IMPORTANT NOTE: if you however have scanned in documents with "OCR" on (character recognition), rather than just scanned them in as pure images, your collection and its users will greatly benefit from enabling full text searching for the new collection. To provide full text searching for your collection, click on the Design pane within GLI, then select "Search Indexes" to the left and press the "New Index..." button the right. At the top of the New Index dialog that appears, tick the topmost box, which should be labelled "Full text". Then press the "Add Index" button.
-
-You can now quit GLI. 
-
-6. Move all the contents of the "import" folder produced at the end of step 3 above, excluding its toplevel "metadata.xml" file, into your Greenstone 3 installation's web/sites/localsite/collect/<new collection's name>/import folder. (Where "new collection's name" is the simplified name that got assigned to the new collection you created in step 5.)
-You can now delete the "import" folder you created in step 3.
-
-7. Run GLI again and use File > Open... to open the collection you created in step 5. 
-
-8. OPTIONAL STEP: If you want to add additional "tags" to documents or folders, to allow browsing or searching by them, then go to GLI's Enrich pane. On the left, select all files/folders for which a particular tag value is applicable and, on the right, assign this to the field labelled "er.Tag". You can create multiple er.Tags for any file/folder (or selection thereof) by hitting Enter after assigning a value for an er.Tag. This will allow you to enter a second Tag value, and so on.
-Then select other files and folders for which other tag(s) apply, and assign them similarly, until you've assigned all the tag metadata you want to the various files and folders.
-
-BEWARE: if you ever recreate your collection's "import" folder contents as in steps 3 and 6, you will lose any er.Tag values you assigned through GLI.
-
-In order to be enable Searching and Browsing by the tags you assigned, go to GLI > Design pane.
-- Choose "Search Indexes" on the right, then press the "New Index" button. In the popup dialog, scroll down until you see "er.Tag" and tick its box. Press "Add Index". Now you've prepared your collection to allow searching by tags.
-- Next, choose "Browsing Classifiers" on the left, then at the bottom on the right set "Select classifier to add" to "List" and press "Add Classifier". The dialog that pops up, next to the "metadata" configuration option at the top, choose "er.Tag" from its drop down values. Scroll further down in the dialog until you see the "buttonname" option and type "tags" as its value. Press "OK" to close the dialog. You've now configured your collection to allow users to browse by the tagging metadata that you've assigned.
-- One last thing to improve the display, go to the Format pane, select "Search" on the LEFT then you should see an Index on "er.Tag" to the right. Type "tags" in its value field, so that when the user wants to search by tags, they see the word "tags" for the index name and not "er.Tag" which will be meaningless to them.
-("er" stands for the custom EducationResources.mds metadata set created for the education department.)
-
-9. You're finally ready to rebuild your collection. Still within GLI, click on the Create pane near the top and press the "Build Collection" button. Depending on the size of your collection, this can take some time. Wait until your collection has built successfully and then press the Preview collection which should have become active at this point. Your browser should open up and you should be able to start inspecting the collection you created.
-
-
-
-D. FOR FURTHER INFORMATION ON GREENSTONE
------------------------------------------
-
-a. The instructions above were devised based on the instructions in the many Greenstone 3 tutorials at http://wiki.greenstone.org/doku.php?id=en:tutorials (make sure to click on the "Greenstone 3" tab near the top of that page).
-The Greenstone tutorials are recommended to learn more about Greenstone. For example, you can use what you learn in the "Using UnknownPlugin" section of the "Building a multimedia collection" to learn the basics of using the UnknownPlugin and from there it's a small step to figuring out how to configure the UnknownPlugin in your collection to add support for videos.
-
-b. Once you've gone through the Greenstone 3 tutorials, your understanding of the Greenstone software will be sufficient to understand some more advanced instructions in the Greenstone wiki. For instance, if you want use a CSV file to prepare metadata that is to be assigned to documents by Greenstone (rather than using GLI's Enrich pane), then check out the configuration options for the MetadataCSVPlugin listed at http://wiki.greenstone.org/doku.php?id=en:plugin:metadatacsvplugin
-Assigning er.Tags per filename using a CSV file will allow you to recreate your collection from scratch (by recreating the import folder) as often as you want.
-
-c. You can also join the greenstone-users mailing list to ask Greenstone questions, see http://wiki.greenstone.org/doku.php?id=en:support#central_english_mailing_lists
-Waikato University Education department staff are also welcome to write to us directly, if that's preferred, at greenstone_team@cs.waikato.ac.nz
-
-
-