Index: /main/trunk/model-sites-dev/waikato-edu/collect/README-maths-activities.txt
===================================================================
--- /main/trunk/model-sites-dev/waikato-edu/collect/README-maths-activities.txt	(revision 33696)
+++ /main/trunk/model-sites-dev/waikato-edu/collect/README-maths-activities.txt	(revision 33696)
@@ -0,0 +1,117 @@
+------------------------------------------
+README FOR THE MATH ACTIVITIES COLLECTION
+------------------------------------------
+INDEX:
+A. RECREATING THE maths-activities GREENSTONE COLLECTION's import FOLDER'S CONTENTS FROM SCRATCH
+B. INSTRUCTIONS ON REBUILDING THE maths-activities GREENSTONE COLLECTION, IF THE COLLECTION'S import FOLDER IS NON-EMPTY
+C. HOW TO CREATE ANOTHER EDUCATION DEPT'S ACTIVITY COLLECTION
+D. FOR FURTHER INFORMATION ON GREENSTONE
+
+
+
+A. RECREATING THE maths-activities GREENSTONE COLLECTION's import FOLDER'S CONTENTS FROM SCRATCH
+---------------------------------------------------------------------------------------------
+This section deals with preparing the import folder of the maths-activities so you can rebuild it with updated data.
+This section of the README contains instructions exclusive to Windows machines. However, a Greenstone collection's "import" folder that's prepared according to these instructions on a Windows machine, can then be moved into a "maths-activities" collection on Unix (Linux and Mac) operating systems that run Greenstone 3.09 or later.
+
+You would choose to recreate the import folder's contents of the maths-activities from scratch if:
+- your Greenstone 3 installation's web/sites/waikato-edu/collect/maths-activities/import subfolder is empty
+- you have reorganised files and folders in the Math Resources Activities folder that serves as source (input) to creating the "maths-activities" collection's "import" subfolder.
+
+To prepare the maths-activities/import folder's contents from scratch, first request access to the Math Resources Activities (digitised materials) from the University's Education Deparment.
+Then follow the instructions below.
+
+0. Inspect the image "screenshot-input-mathfolder-organisation.png" which is a screengrab of how the contents of the Math Resource Activities folder could be organised. In the screenshot:
+- The top-level folder structure of the Math Resource Activities is shown to the right within the screenshot, and to the left you can see that one of the primary Activities, Algebra, has been expanded revealing the folder structure underneath.
+- A further subfolder is also expanded on the left: "Hooked on Algebra". Not shown is that this subfolder, expanded as an example, contains the files "Fishy Algebra.jpg" and "Hooked on Algebra.pdf".
+
+Kathy Li (Li Liang) organised the contents of the Math Resource Activities folder as seen in the screenshot. Others may decide on a different organisation of its contents. In that case, you want to make sure that your Math Resources Activities folder is hierarchically organised in a similarly sensible fashion. You're free to move across folders and subfolders as you please, and add new ones, just be aware that the folder and subfolder hierarchical structure you create within Math Resources Activities will be reflected in the final Greenstone collection.
+
+IMPORTANT: Also be aware that while the code can cope with spaces, you want to avoid "&" and other tricky characters (e.g. proper quote marks) in names of files and folders. Naming things correctly at this stage will save a lot of grief later. Use "and" in place of "&" for instance in file/folder names, drop quotation marks and colons. If in doubt about any character, replace with a simpler one. Hyphens and underscores are fine. Replace forward slashes, "/", in file/folder names, because "/" has a special meaning in Greenstone.
+
+1. Once you've finished reorganising the Math Resources Activities folder, copy the custom made Windows specific script file "procMath.bat", located at "web/sites/waikato-edu/collect/maths-activities/DATA-PREPARATION/procMath.bat", into the top level of the Math Resources Activities folder.
+
+2. Move into your Math Resources Activities folder where the copy of the procMath.bat file resides. Double-click that procMath.bat file and it should run against the structured contents within your Math Resources Activities folder. You can see it's doing something because a black window should pop up wherein lots of text is displayed.
+
+NOTE: If you have heard of something called the "Windows DOS prompt" and know how to use it, you can use the DOS prompt to run the procMath.bat file too, instead of double clicking it as described above. This is useful for finding any issues (a process known as "debugging") in the event that something goes wrong in processing your Math Resources Activities folder. For example, if you used unacceptable characters in file and folder names.
+
+3. After a little while the black window that popped up should disappear again, meaning the procMath.bat script has finished processing your Math Resources Activities folder. 
+
+As a result of running procMath.bat successfully, you'll now have a folder called "import" residing at the same level as your Math Resources Activities folder.
+
+4. Move all the contents of this import folder, except its toplevel "metadata.xml" file into your Greenstone 3 installation's web/sites/waikato-edu/collect/maths-activities/import folder.
+Then you may choose to delete the "import" folder produced in steps 2 and 3 above.
+
+5. Proceed with the "B. INSTRUCTIONS ON REBUILDING THE maths-activities GREENSTONE COLLECTION, IF THE COLLECTION'S import FOLDER IS NON-EMPTY" below.
+
+
+
+B. INSTRUCTIONS ON REBUILDING THE maths-activities GREENSTONE COLLECTION, IF THE COLLECTION'S import FOLDER IS NON-EMPTY
+---------------------------------------------------------------------------------------------------------------------
+
+To build the maths-activities Greenstone collection (the Math Activities collection), assuming you already have the contents of the collection "import" folder (if not, see instructions under section A above):
+
+1. Run the GLI (Greenstone Librarian Interface) application.
+
+2. Open the maths-activities collection in GLI. 
+
+3. Go into the Create panel and press the Build collection button.
+Some minutes later, the Preview Collection button will become active, meaning your collection has been built and is ready to preview. (If the Preview button does not become active despite the build process indicating that it finished "successfully", quit GLI, reopen the collection and repeat steps 2-4. You can always email us on the mailing list at greenstone_team@cs.waikato.ac.nz.)
+
+
+
+C. HOW TO CREATE A NEW ACTIVITY COLLECTION SIMILAR TO maths-activities
+-----------------------------------------------------------------------
+You can create a different, new Greenstone collection similar to the Math collection by following the steps below.
+Note that step 2 below requires a Windows machine, but the remaining steps can be done on other operating systems such as Linux and Mac where you have a Greenstone 3 installed and have got the same "waikato-edu" Greenstone site set up within it.
+
+1. Organise your content in a sensible hierarchical folder structure. As mentioned earlier in this README, check your file and folder names don't have "&", "/", quotes and any other characters that you think might be problematic (replace them with other characters or indicative words, e.g. replace "&" with "and").
+
+2.  THE SCRIPT IN THIS STEP REQUIRES A Windows MACHINE.
+Copy the script file "web/sites/waikato-edu/collect/maths-activities/DATA-PREPARATION/procMath.bat" into the toplevel folder of the material you organised in step 1.
+
+3. Double click on the procMath.bat script. A black window will pop up. It will disappear once the script has finished processing your folder's contents.
+At the end of this process, you'll have ended up with a folder called "import" at the same level as the toplevel folder of the material you organised in step 1.
+
+4. Run the Greenstone Librarian Interface, GLI. You'll now create a new collection based on the maths-activities:
+Go to GLI's File > New... menu. Give the new collection a name, optionally add a description. Then in the drop-down box for "Base This Collection On", choose the Maths Activities collection (maths-activities). Press OK.
+Your new collection will now have inherited the custom metadata set and overall collection design of the Math Activities collection. So you don't need to put in any effort to get the same behaviour from your new collection.
+
+IMPORTANT NOTE: if you however have scanned in documents with "OCR" on (character recognition), rather than just scanned them in as pure images, your collection and its users will greatly benefit from enabling full text searching for the new collection. To provide full text searching for your collection, click on the Design pane within GLI, then select "Search Indexes" to the left and press the "New Index..." button the right. At the top of the New Index dialog that appears, tick the topmost box, which should be labelled "Full text". Then press the "Add Index" button.
+
+You can now quit GLI. 
+
+5. Move all the contents of the "import" folder produced at the end of step 3 above, excluding its toplevel "metadata.xml" file, into your Greenstone 3 installation's web/sites/waikato-edu/collect/<new collection's name>/import folder. (Where "new collection's name" is the simplified name that got assigned to the new collection you created in step 4.)
+You can now delete the "import" folder you created in step 3.
+
+6. Run GLI again and use File > Open... to open the collection you created in step 4. 
+
+7. OPTIONAL STEP: If you want to add additional "tags" to documents or folders, to allow browsing or searching by them, then go to GLI's Enrich pane. On the left, select all files/folders for which a particular tag value is applicable and, on the right, assign this to the field labelled "er.Tag". You can create multiple er.Tags for any file/folder (or selection thereof) by hitting Enter after assigning a value for an er.Tag. This will allow you to enter a second Tag value, and so on.
+Then select other files and folders for which other tag(s) apply, and assign them similarly, until you've assigned all the tag metadata you want to the various files and folders.
+
+BEWARE: if you ever recreate your collection's "import" folder contents as in steps 3 and 5, you will lose any er.Tag values you assigned through GLI.
+
+In order to enable Searching and Browsing by the tags you assigned, go to GLI > Design pane.
+- Choose "Search Indexes" on the right, then press the "New Index" button. In the popup dialog, scroll down until you see "er.Tag" and tick its box. Press "Add Index". Now you've prepared your collection to allow searching by tags.
+- Next, choose "Browsing Classifiers" on the left, then at the bottom on the right set "Select classifier to add" to "List" and press "Add Classifier". The dialog that pops up, next to the "metadata" configuration option at the top, choose "er.Tag" from its drop down values. Scroll further down in the dialog until you see the "buttonname" option and type "tags" as its value. Press "OK" to close the dialog. You've now configured your collection to allow users to browse by the tagging metadata that you've assigned.
+- One last thing to improve the display, go to the Format pane, select "Search" on the LEFT then you should see an Index on "er.Tag" to the right. Type "tags" in its value field, so that when the user wants to search by tags, they see the word "tags" for the index name and not "er.Tag" which will be meaningless to them.
+("er" stands for the custom EducationResources.mds metadata set created for the education department.)
+
+8. You're finally ready to rebuild your collection. Still within GLI, click on the Create pane near the top and press the "Build Collection" button. Depending on the size of your collection, this can take some time. Wait until your collection has built successfully and then press the Preview collection which should have become active at this point. Your browser should open up and you should be able to start inspecting the collection you created.
+
+
+
+D. FOR FURTHER INFORMATION ON GREENSTONE
+-----------------------------------------
+
+a. The instructions above were devised based on the instructions in the many Greenstone 3 tutorials at http://wiki.greenstone.org/doku.php?id=en:tutorials (make sure to click on the "Greenstone 3" tab near the top of that page).
+The Greenstone tutorials are recommended to learn more about Greenstone. For example, you can use what you learn in the "Using UnknownPlugin" section of the "Building a multimedia collection" to learn the basics of using the UnknownPlugin and from there it's a small step to figuring out how to configure the UnknownPlugin in your collection to add support for videos.
+
+b. Once you've gone through the Greenstone 3 tutorials, your understanding of the Greenstone software will be sufficient to understand some more advanced instructions in the Greenstone wiki. For instance, if you want use a CSV file to prepare metadata that is to be assigned to documents by Greenstone (rather than using GLI's Enrich pane), then check out the configuration options for the MetadataCSVPlugin listed at http://wiki.greenstone.org/doku.php?id=en:plugin:metadatacsvplugin
+Assigning er.Tags per filename using a CSV file will allow you to recreate your collection from scratch (by recreating the import folder) as often as you want.
+
+c. You can also join the greenstone-users mailing list to ask Greenstone questions, see http://wiki.greenstone.org/doku.php?id=en:support#central_english_mailing_lists
+
+
+
+
Index: /main/trunk/model-sites-dev/waikato-edu/collect/README-science-activities.txt
===================================================================
--- /main/trunk/model-sites-dev/waikato-edu/collect/README-science-activities.txt	(revision 33696)
+++ /main/trunk/model-sites-dev/waikato-edu/collect/README-science-activities.txt	(revision 33696)
@@ -0,0 +1,106 @@
+--------------------
+  README
+--------------------
+A. RECREATING THE science-activities GREENSTONE COLLECTION's import FOLDER'S CONTENTS FROM SCRATCH
+B. REBUILDING THE science-activities COLLECTION
+C. VIEWING THE COLLECTION WHEN IT'S ALREADY BEEN BUILT
+D. INFORMATION AND WARNINGS
+
+
+
+A. RECREATING THE science-activities GREENSTONE COLLECTION's import FOLDER'S CONTENTS FROM SCRATCH
+---------------------------------------------------------------------------------------------------
+ONLY if you ever want to REGENERATE the folders for ingesting into GS3 your crate folders, PDF/Word files and metadata, then:
+
+0. Obtain the TT4.02 Science Resources Crates content from the Uni of Waikato Education Department. We do not have the permission to distribute it or make it public.
+But assuming the Education Dept. has given this content you in a zip format, follow the instructions below.
+
+1. Extract the TT4.02_Science Resources_Crates.zip, which will create a folder called TT4.02_Science Resources_Crates.
+For example, extract it on the Desktop and your Windows desktop will now have a new folder called "TT4.02_Science Resources_Crates".
+If not already present, obtain the 14 .csv files labelled between A-1 to F-2 from the Education department and put them into the new TT4.02_Science Resources_Crates folder.
+
+2. Next, move the file web/sites/waikato-edu/collect/science-activities/DATA-PREPARATION/procCrates.bat into the new TT4.02_Science Resources_Crates folder as well.
+
+In our example, your extracted TT4.02_Science Resources_Crates was on the Desktop, e.g. at C:\Users\You\Desktop\TT4.02_Science Resources_Crates
+Whatever the actual location, remember it and use it in the following. I will stick with the example of C:\Users\You\Desktop\TT4.02_Science Resources_Crates
+
+Double-click on the procCrates.bat script.
+
+Wait until the procCrates.bat script has finished processing the TT4.02_Science Resources_Crates folder contents. It should have created a folder called "import" in C:\Users\You\Desktop\TT4.02_Science Resources_Crates.
+
+[ONLY IF things didn't work out correctly in step a, then you can delete any folder called "import" that it produced and run the procCrates.bat script manually, to look for any issues.
+
+Open a DOS prompt:
+	first hold down the Windows key on the keyboard (located between Alt and Ctrl keys) and press the R key (R for run);
+	then a little dialog will pop up. Type "cmd" into its edit field and press enter and a DOS prompt will appear.
+
+In the DOS prompt, type:
+	cd C:\Users\You\Desktop\TT4.02_Science Resources_Crates
+(i.e. "cd" followed by the full path to the actual location of your extracted folder)
+
+Next type:
+	procCrates.bat
+
+Wait for the script to finish.
+]
+
+3. ONLY if you now want to reingest and rebuild your collection with the contents of the new import folder, use a file browser to do the following:
+- Delete all except the top-level metadata.xml file in your Greenstone 3 installation's "web/sites/waikato-edu/collect/science-activities/import" folder.
+- Go into the "C:\Users\You\Desktop\TT4.02_Science Resources_Crates\import" folder. You should see subfolders A-1 to F-2.
+- MOVE all these into your Greenstone 3 installation's "web/sites/waikato-edu/collect/science-activities/import" folder, where you should already have the old solitary metadata.xml file at this level.
+
+To rebuild the science-activities collection, follow the instructions under "REBUILDING THE SCIENCE ACTIVITIES COLLECTION" below.
+
+
+
+B. REBUILDING THE science-activities COLLECTION
+------------------------------------------------
+1. Run the GLI/Greenstone Librarian Interface application of your installed Greenstone.
+2. In GLI, select File > Open. Choose your "science-activities" collection.
+3. When this finishes opening, click on the Create tab in GLI.
+4. Find the Build Collection button at the bottom and press it. This can take a long time, maybe 15 mins or more. Eventually it will finish building and you can press the Preview button also at the bottom of the Create pane to have it open a browser for you and show you the finished collection.
+
+
+
+C. VIEWING THE COLLECTION WHEN IT'S ALREADY BEEN BUILT BEFORE
+--------------------------------------------------------------
+You only have to rebuild a collection when you make changes to it or if it's never been built before.
+Otherwise, if a collection has already been built at some point and hasn't been modified since, you can preview it directly as follows.
+
+Start your Greenstone's installation's "Greenstone Server" application. Pressing this application's "Enter Library" button should open your default browser on your Greenstone DL home page. Visit your new science-activities collection, as it's prebuilt.
+
+
+
+D. INFORMATION AND WARNINGS
+----------------------------
+- I exported each crate's .csv file individually from Excel (by default it exports in ASCII encoding format, so I left it as such and let the procCrates.bat script deal with this).
+I did this by opening the "Crates (TT4.02).xlsx" file that was in the TT4.02_Science Resources_Crates.zip downloaded from your Google drive. Then I clicked on each sheet and did Save As > *.csv (the most basic CSV option).
+
+- the procCrates.bat now processes each crate's csv file and outputs additional metadata from before.
+In processing each csv file, it simplifies the Activity Name (handles &, ", ', etc) to make it more compatible as metadata for Greenstone.
+NOTE: I have had to change / (forward slash) to ; (semi-colon) as the / is used as a hierarchy separator by the browsing classifier code.
+
+- The collections in the "waikato-edu" Greenstone site make use of the custom Greenstone metadata set file "educationresources.mds".
+It can be found at waikato-edu/collect/science-activities/metadata/educationresources.mds (if you've already moved the waikato-edu site into your Greenstone 3 installation, it can be found within your Greenstone 3 installation directory at web/sites/waikato-edu/collect/science-activities/metadata/educationresources.mds).
+	* You can copy the educationresources.mds file into gli/metadata to re-use it for other collections you create from scratch.
+	* Alternatively, any collection created based on the science-activities collection will automatically inherit a copy of hte educationresources.mds Greenstone metadata set file.
+	
+- I've modified web/sites/waikato-edu/siteConfig.xml with a single additional line to have a word icon for docx files too (not just for the old .doc files). The additional line is:
+	<replace macro="_icondocx_" scope="metadata" text="&lt;img src='interfaces/default/images/imsword.gif' border='0'/&gt;" resolve="false"/>
+
+- In GLI's Design tab, I configured the plugins used to build your collection, and set up the search indexes and browsing classifiers that should be available:
+	only one search Index on ActivityName, as you requested
+	and one browsing classifier that works with the newly introduced er.CrateHierarchy metadata
+- I used GLI's Format tab to set up the display of the search results and browsing classifier content.
+Basically, when you BROWSE to an activity, under the activity name you will see its document(s). For each document: you get an icon linked to the HTML version of each document (produced by Greenstone), an appropriate icon linking to the original document format (PDF or docx) and the FILENAME of the document, since the activity name of the browser is what the filename is found under.
+When you SEARCH for an activity name or part of an activity name, you once more get the HTML doc icon and source doc icon but this is then further followed by the ACTIVITY NAME and then the filename in brackets.
+
+Based on the changes made to GLI's Design and Format panels, a customised collectionConfig.xml is generated for this collection. When you create future collections through GLI, you can use "Base collection on" option in GLI's New Collection dialog to base those future collections on the design and formatting of this collection (make sure you assign the same metadata). Making this choice in GLI will automatically reuse the same collectionConfig.xml, inheriting all its configurations. The new collection thus created will also get to use the same metadata sets, including the custom one we prepared, "educationresources.mds".
+
+So all the hard work here went into procCrates.bat and into setting up the collection's configuration, which produced collectionConfig.xml.
+
+
+WARNINGS
+Beware not to change the encoding of procCrates.bat from ASCII to UTF-8 or other encodings. If you wish to edit this file, open it in Notepad++ and leave it's encoding in ASCII.
+
+------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Index: in/trunk/model-sites-dev/waikato-edu/collect/maths-activities/DATA-PREPARATION/README-maths.txt
===================================================================
--- /main/trunk/model-sites-dev/waikato-edu/collect/maths-activities/DATA-PREPARATION/README-maths.txt	(revision 33695)
+++ 	(revision )
@@ -1,121 +1,0 @@
-------------------------------------------
-README FOR THE MATH ACTIVITIES COLLECTION
-------------------------------------------
-INDEX:
-A. RECREATING THE maths-activities GREENSTONE COLLECTION's import FOLDER'S CONTENTS FROM SCRATCH
-B. INSTRUCTIONS ON REBUILDING THE maths-activities GREENSTONE COLLECTION, IF THE COLLECTION'S import FOLDER IS NON-EMPTY
-C. HOW TO CREATE ANOTHER EDUCATION DEPT'S ACTIVITY COLLECTION
-D. FOR FURTHER INFORMATION ON GREENSTONE
-
-
-
-A. RECREATING THE maths-activities GREENSTONE COLLECTION's import FOLDER'S CONTENTS FROM SCRATCH
----------------------------------------------------------------------------------------------
-This section deals with preparing the import folder of the maths-activities so you can rebuild it with updated data.
-This section of the README contains instructions exclusive to Windows machines. However, a Greenstone collection's "import" folder that's prepared according to these instructions on a Windows machine, can then be moved into a "maths-activities" collection on Unix (Linux and Mac) operating systems that run Greenstone 3.09 or later.
-
-You would choose to recreate the import folder's contents of the maths-activities from scratch if:
-- the maths-activities/import subfolder is empty
-- you have moved about some files and folders of the Math Resource Activities folder that serves as source (input) to creating the maths-activities's import subfolder.
-
-To prepare the maths-activities/import folder's contents from scratch,
-
-0. Inspect the image "screenshot-input-mathfolder-organisation.png" which is a screengrab of how the contents of the Math Resource Activities folder could be organised. In the screenshot:
-- The top-level folder structure of the Math Resource Activities is shown to the right within the screenshot, and to the left you can see that one of the primary Activities, Algebra, has been expanded revealing the folder structure underneath.
-- A further subfolder is also expanded on the left: "Hooked on Algebra". Not shown is that this subfolder, expanded as an example, contains the files "Fishy Algebra.jpg" and "Hooked on Algebra.pdf".
-
-Liang Li organised the contents of the Math Resource Activities folder as seen in the screenshot. Others may decide on a different organisation of its contents. 
-In that case, you want to make sure that your Math Resources Activities folder is hierarchically organised in a similarly sensible fashion. You're free to move across folders and subfolders as you please, and add new ones, just be aware that the folder and subfolder hierarchical structure you create within Math Resources Activities will be reflected in the final Greenstone collection. 
-IMPORTANT: Also be aware that while the code can cope with spaces, you want to avoid "&" and other tricky characters (e.g. proper quote marks) in names of files and folders. Naming things correctly at this stage will save a lot of grief later. Use "and" in place of "&" for instance in file/folder names, drop quotation marks and colons. If in doubt about any character, replace with a simpler one. Hyphens and underscores are fine. Replace forward slashes, "/", in file/folder names, because "/" has a special meaning in Greenstone.
-
-1. Once you've finished reorganising the Math Resources Activities folder, copy the file "procMath.bat" (a custom made Windows specific script) into the top level of the Math Resources Activities folder.
-
-2. Double-click the procMath.bat file and it should run against the structured contents within your Math Resources Activities folder. You can see it's doing something because a black window should pop up wherein lots of text is displayed.
-
-NOTE: If you have heard of something called the "Windows DOS prompt" and know how to use it, you can use the DOS prompt to run the procMath.bat file too, instead of double clicking it as described above. This is useful for finding any issues (a process known as "debugging") in the event that something goes wrong in processing your Math Resources Activities folder. For example if you used unacceptable characters in file and folder names.
-
-3. After a little while the black window that popped up should disappear again, meaning the procMath.bat script has finished processing your Math Resources Activities folder. 
-
-As a result of running procMath.bat successfully, you'll now have a folder called "import" residing at the same level as your Math Resources Activities folder.
-
-4. Move all the contents of this import folder, except its toplevel "metadata.xml" file into your "maths-activities/import" subfolder. Then you may delete the "import" folder produced in steps 2 and 3 above.
-
-5. Proceed with the "B. INSTRUCTIONS ON REBUILDING THE maths-activities GREENSTONE COLLECTION, IF THE COLLECTION'S import FOLDER IS NON-EMPTY" below.
-
-
-
-B. INSTRUCTIONS ON REBUILDING THE maths-activities GREENSTONE COLLECTION, IF THE COLLECTION'S import FOLDER IS NON-EMPTY
----------------------------------------------------------------------------------------------------------------------
-
-To build the maths-activities Greenstone collection (the Math Activities collection), assuming you already have the contents of the collection "import" folder (if not, see instructions under section A above):
-
-0. Follow any instructions in the EducationDept/README.txt file first.
-
-1. Move the maths-activities into a Greenstone 3.09 installation's web/sites/waikato-edu/collect/ folder.
-
-2. Run the GLI (Greenstone Librarian Interface) application.
-
-3. Open the maths-activities collection in GLI. 
-
-4. Go into the Create panel and press the Build collection button.
-Some minutes later, the Preview Collection button will become active, meaning your collection has been built and is ready to preview. (If the Preview button does not become active despite the build process indicating that it finished "successfully", quit GLI, reopen the collection and repeat steps 2-4. You can always email us on the mailing list at greenstone_team@cs.waikato.ac.nz.)
-
-
-
-C. HOW TO CREATE ANOTHER EDUCATION DEPT'S ACTIVITY COLLECTION
--------------------------------------------------------------
-You can create a different, new Greenstone collection similar to the Math collection by following the steps below.
-Note that step 2 below requires a Windows machine, but the remainding steps can be done on other operating systems such as Linux and Mac.
-
-1. Organise your content in a sensible hierarchical folder structure. As mentioned earlier in this README, check your file and folder names don't have "&", "/", quotes and any other characters that you think might be problematic (replace them with other characters or indicative words, e.g. replace "&" with "and").
-
-2.  THE SCRIPT IN THIS STEP REQUIRES A Windows MACHINE.
-Put the script file "procMath.bat" into the toplevel folder of the material you organised in step 1.
-
-3. Double click on the procMath.bat script. A black window will pop up. It will disappear once the script has finished processing your folder's contents.
-At the end of this process, you'll have ended up with a folder called "import" at the same level as the toplevel folder of the material you organised in step 1.
-
-4. Ensure that your Greenstone 3 installation's web/sites/waikato-edu/collect subfolder contains the maths-activities folder. If it doesn't already exist there, copy it into there.
-
-5. Run the Greenstone Librarian Interface, GLI. You'll now create a new collection based on the maths-activities:
-Go to GLI's File > New... menu. Give the new collection a name, optionally add a description. Then in the drop-down box for "Base This Collection On", choose the Maths Activities collection (maths-activities). Press OK.
-Your new collection will now have inherited the custom metadata set and overall collection design of the Math Activities collection. So you don't need to put in any effort to get the same behaviour from your new collection.
-
-IMPORTANT NOTE: if you however have scanned in documents with "OCR" on (character recognition), rather than just scanned them in as pure images, your collection and its users will greatly benefit from enabling full text searching for the new collection. To provide full text searching for your collection, click on the Design pane within GLI, then select "Search Indexes" to the left and press the "New Index..." button the right. At the top of the New Index dialog that appears, tick the topmost box, which should be labelled "Full text". Then press the "Add Index" button.
-
-You can now quit GLI. 
-
-6. Move all the contents of the "import" folder produced at the end of step 3 above, excluding its toplevel "metadata.xml" file, into your Greenstone 3 installation's web/sites/waikato-edu/collect/<new collection's name>/import folder. (Where "new collection's name" is the simplified name that got assigned to the new collection you created in step 5.)
-You can now delete the "import" folder you created in step 3.
-
-7. Run GLI again and use File > Open... to open the collection you created in step 5. 
-
-8. OPTIONAL STEP: If you want to add additional "tags" to documents or folders, to allow browsing or searching by them, then go to GLI's Enrich pane. On the left, select all files/folders for which a particular tag value is applicable and, on the right, assign this to the field labelled "er.Tag". You can create multiple er.Tags for any file/folder (or selection thereof) by hitting Enter after assigning a value for an er.Tag. This will allow you to enter a second Tag value, and so on.
-Then select other files and folders for which other tag(s) apply, and assign them similarly, until you've assigned all the tag metadata you want to the various files and folders.
-
-BEWARE: if you ever recreate your collection's "import" folder contents as in steps 3 and 6, you will lose any er.Tag values you assigned through GLI.
-
-In order to be enable Searching and Browsing by the tags you assigned, go to GLI > Design pane.
-- Choose "Search Indexes" on the right, then press the "New Index" button. In the popup dialog, scroll down until you see "er.Tag" and tick its box. Press "Add Index". Now you've prepared your collection to allow searching by tags.
-- Next, choose "Browsing Classifiers" on the left, then at the bottom on the right set "Select classifier to add" to "List" and press "Add Classifier". The dialog that pops up, next to the "metadata" configuration option at the top, choose "er.Tag" from its drop down values. Scroll further down in the dialog until you see the "buttonname" option and type "tags" as its value. Press "OK" to close the dialog. You've now configured your collection to allow users to browse by the tagging metadata that you've assigned.
-- One last thing to improve the display, go to the Format pane, select "Search" on the LEFT then you should see an Index on "er.Tag" to the right. Type "tags" in its value field, so that when the user wants to search by tags, they see the word "tags" for the index name and not "er.Tag" which will be meaningless to them.
-("er" stands for the custom EducationResources.mds metadata set created for the education department.)
-
-9. You're finally ready to rebuild your collection. Still within GLI, click on the Create pane near the top and press the "Build Collection" button. Depending on the size of your collection, this can take some time. Wait until your collection has built successfully and then press the Preview collection which should have become active at this point. Your browser should open up and you should be able to start inspecting the collection you created.
-
-
-
-D. FOR FURTHER INFORMATION ON GREENSTONE
------------------------------------------
-
-a. The instructions above were devised based on the instructions in the many Greenstone 3 tutorials at http://wiki.greenstone.org/doku.php?id=en:tutorials (make sure to click on the "Greenstone 3" tab near the top of that page).
-The Greenstone tutorials are recommended to learn more about Greenstone. For example, you can use what you learn in the "Using UnknownPlugin" section of the "Building a multimedia collection" to learn the basics of using the UnknownPlugin and from there it's a small step to figuring out how to configure the UnknownPlugin in your collection to add support for videos.
-
-b. Once you've gone through the Greenstone 3 tutorials, your understanding of the Greenstone software will be sufficient to understand some more advanced instructions in the Greenstone wiki. For instance, if you want use a CSV file to prepare metadata that is to be assigned to documents by Greenstone (rather than using GLI's Enrich pane), then check out the configuration options for the MetadataCSVPlugin listed at http://wiki.greenstone.org/doku.php?id=en:plugin:metadatacsvplugin
-Assigning er.Tags per filename using a CSV file will allow you to recreate your collection from scratch (by recreating the import folder) as often as you want.
-
-c. You can also join the greenstone-users mailing list to ask Greenstone questions, see http://wiki.greenstone.org/doku.php?id=en:support#central_english_mailing_lists
-Waikato University Education department staff are also welcome to write to us directly, if that's preferred, at greenstone_team@cs.waikato.ac.nz
-
-
-
Index: in/trunk/model-sites-dev/waikato-edu/collect/science-activities/DATA-PREPARATION/README-science.txt
===================================================================
--- /main/trunk/model-sites-dev/waikato-edu/collect/science-activities/DATA-PREPARATION/README-science.txt	(revision 33695)
+++ 	(revision )
@@ -1,78 +1,0 @@
---------------------
-  README
---------------------
-
-Obtain the TT4.02 Science Resources Crates content from the Uni of Waikato Education Department. We do not have the permission to distribute it or make it public.
-But assuming the Education Dept. has given this content you in a zip format, follow the instructions below.
-
-1. Extract the TT4.02_Science Resources_Crates.zip, which will create a folder called TT4.02_Science Resources_Crates.zip
-For example, extract it on the Desktop and your Windows desktop will now have a new folder TT4.02_Science Resources_Crates.
-
-2. Next, move the files procCrates.bat and all 14 of the .csv files (A-1 to F-2) into the new TT4.02_Science Resources_Crates folder
-
-3. Move the "sciencea.gs3coll" folder into your Greenstone 3.09rc1 installation's "web\sites\localsite\collect" folder.
-
-4. Move the siteConfig.xml file  into your Greenstone 3.09rc1 installation's "web\sites\localsite" folder, thereby replacing the existing file there.
-
-5. Start your Greenstone's installation's "Greenstone Server" application. Pressing this application's "Enter Library" button should open your default browser on your Greenstone DL home page. Visit your new Science Activities collection, as it's prebuilt.
-
---------------------
-TO REGENERATE THE MATERIALS FOR YOUR COLLECTION AND TO REBUILD THAT COLLECTION:
-4. ONLY if you ever want to REGENERATE the folders for ingesting into GS3 your crate folders, PDF/Word files and metadata, then:
-
-In our example, your extracted TT4.02_Science Resources_Crates was on the Desktop, e.g. C:\Liang\Desktop\TT4.02_Science Resources_Crates
-Whatever the actual location, remember it and use it in the following. I will stick with the example of C:\Liang\Desktop\TT4.02_Science Resources_Crates
-
-a. Open a DOS prompt:
-	first hold down the Windows key on the keyboard (located between Alt and Ctrl keys) and press the R key (R for run);
-	then a little dialog will pop up. Type "cmd" into its edit field and press enter and a DOS prompt will appear.
-
-In the DOS prompt, type:
-	cd C:\Liang\Desktop\TT4.02_Science Resources_Crates
-(i.e. "cd" followed by the full path to the actual location of your extracted folder)
-
-b. type:
-	procCrates.bat
-	
-c. Wait until it finishes. It should have created a folder called "import" in C:\Liang\Desktop\TT4.02_Science Resources_Crates.
-
-d. ONLY if you now want to reingest and rebuild your collection with these new folders, use a file browser to do the following:
-- Delete all but the top-level metadata.xml file in your Greenstone 3.09 (rc1) installation's "web\sites\localsite\collect\sciencea\import" folder.
-- Go into the "C:\Liang\Desktop\TT4.02_Science Resources_Crates\import" folder. You should see subfolders A-1 to F-2.
-- MOVE all these into your Greenstone 3.09 (rc1) installation's "web\sites\localsite\collect\sciencea\import" folder, where you should already have the old solitary metadata.xml file at this level.
-
-e. Run the GLI/Greenstone Librarian Interface application of your installed Greenstone.
-In GLI, select File > Open. Choose your "Science Activities (sciencea)" collection.
-When this finishes opening, click on the Create tab in GLI.
-Find the Build Collection button at the bottom and press it. This can take a long time, maybe 15 mins or more. Eventually it will finish building and you can press the Preview button also at the bottom of the Create pane to have it open a browser for you and show you the finished collection.
-
---------------------
-INFORMATION:
-- I exported each crate's .csv file individually from Excel (by default it exports in ASCII encoding format, so I left it as such and let procCrates.bat below deal with this).
-I did this by opening the "Crates (TT4.02).xlsx" file that was in the TT4.02_Science Resources_Crates.zip downloaded from your Google drive. Then I clicked on each sheet and did Save As > *.csv (the most basic CSV option).
-
-- the procCrates.bat now processes each crate's csv file and outputs additional metadata from before.
-In processing each csv file, it simplifies the Activity Name (handles &, ", ', etc) to make it more compatible as metadata for Greenstone.
-NOTE: I have had to change / (forward slash) to ; (semi-colon) as the / is used as a hierarchy separator by the browsing classifier code.
-
-- I've modified the Education Resources metadata set to have an extra field called CrateHierarchy, which makes it easier to produce the book nodes.
-The educationresources.mds (metadata set file) lives inside your web\sites\localsite\collect\sciencea\metadata folder. You can copy it into gli\metadata to re-use it for other collections.
-- I've modified web\sites\localsite\siteConfig.xml with a single additional line to have a word icon for docx files too (not just for the old .doc files). The additional line is:
-	<replace macro="_icondocx_" scope="metadata" text="&lt;img src='interfaces/default/images/imsword.gif' border='0'/&gt;" resolve="false"/>
-
-- In GLI's Design tab, I configured the plugins used to build your collection, and set up the search indexes and browsing classifiers that should be available:
-	only one search Index on ActivityName, as you requested
-	and one browsing classifier that works with the newly introduced er.CrateHierarchy metadata
-- I used GLI's Format tab to set up the display of the search results and browsing classifier content.
-Basically, when you BROWSE to an activity, under the activity name you will see its document(s). For each document: you get an icon linked to the HTML version of each document (produced by Greenstone), an appropriate icon linking to the original document format (PDF or docx) and the FILENAME of the document, since the activity name of the browser is what the filename is found under.
-When you SEARCH for an activity name or part of an activity name, you once more get the HTML doc icon and source doc icon but this is then further followed by the ACTIVITY NAME and then the filename in brackets.
-
-Based on the changes made to GLI's Design and Format panels, a customised collectionConfig.xml is generated for this collection. When you create future collections through GLI, you can use "Base collection on" option in GLI's New Collection dialog to base those future collections on the design and formatting of this collection (make sure you assign the same metadata). Making this choice in GLI will automatically reuse the same collectionConfig.xml, inheriting all its configurations. The new collection thus created will also get to use the same metadata sets, including the custom one we prepared, "educationresources.mds".
-
-So all the hard work here went into procCrates.bat and into setting up the collection's configuration, which produced collectionConfig.xml.
-
---------------------
-BEWARE:
-Beware not to change the encoding of procCrates.bat from ASCII to UTF-8 or other encodings. If you wish to edit this file, open it in Notepad++ and leave it's encoding in ASCII.
-
-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------